//Splitter by aloyark using Wschseng's [A] splitter as a base which was made with the help of Rod, Jeff and me.

/* Some Splits are based on maps rather than Events like Wschsengs original autosplitter
I'll be commenting in the map splits into the events for readability like this //[Done with Maps]

Things I added/changed
	- All Map Splits(This includes the FMV)
	- Kainé reading Louise's letter
    - Fixed Kainé Start to work with B Ending
	- Breached Ship(Ship Discovery) Cutscene
*/

state("NieR Replicant ver.1.22474487139", "1.00") {
	byte Loading: 0x00EE29B0, 0xD4;
	string32 Event: 0x15C3163;
	string32 Map: 0x4372794;
	int BreachedShip: 0x1205EA0;
}

state("NieR Replicant ver.1.22474487139",  "1.03") {
	byte Loading: 0x00EE49C0, 0xD4;
	string32 Event: 0x15C53F3;
	string32 Map: 0x4374A24;
	int BreachedShip: 0x1207EE0;
}

init
{

	byte[] exeMD5HashBytes = new byte[0];
	using (var md5 = System.Security.Cryptography.MD5.Create())
	{
        	using (var s = File.Open(modules.First().FileName, FileMode.Open, FileAccess.Read, FileShare.ReadWrite))
		{
            	exeMD5HashBytes = md5.ComputeHash(s); 
        	}
	}
	var MD5Hash = exeMD5HashBytes.Select(x => x.ToString("X2")).Aggregate((a, b) => a + b);

	print("hashy boi is: " + MD5Hash);
	switch (MD5Hash) {
		case "3306698C51503A7783BD401712d9AC6C":
			version = "1.00";
			break;
		case "E5411222E5247B981EF2B1FC219B770A":
			version = "1.03";
			break;
		case "89E4C3D0AF6C86DB2312FB911DAFEC91":
			version = "1.03";
			break;
	}
	print("ModuleMemorySize: " + modules.First().ModuleMemorySize.ToString());
}

startup {
	vars.Events = new string[] {

		//Jack/Shrine------------------------------------------------------------------------------------------------------------------------------------------
		"eid_3200_a0040",			      //Jack End
		//[Shrine Path Enter]
		//[Shrine Enter]
		"eid_4100_a0070",			      //Gretel Start
		"eid_4100_a0100_b",			      //Kainé start
		//[Kaine]

		//Heap 1------------------------------------------------------------------------------------------------------------------------------------------------
		//[Enter Heap]
		//[Leaving Heap]

		//Seafront----------------------------------------------------------------------------------------------------------------------------------------------
		//[Arriving at seafront]
		//[Breached Shipwreck]
		"eid_9320_a0240",			      //Ship Collapse
		"eid_9320_a0270",			      //Louise Start
		"eid_9320_a0290",			      //Louise Phase 1 End
		"eid_9320_a0370",			      //Louise End
		"eid_9320_a0420",                 //Kainé being cring and ripping the letter

		//Facade------------------------------------------------------------------------------------------------------------------------------------------------
		"eid_4230_a0010",                 //Desert Start
		"eid_4230_a0030",                 //Right Before Wedding and Mansion Stuff
		"eid_4230_a0082",			      //Fyra Dead Fasadge
		"eid_4230_a0090",			      //Mean doggo goes away
		"eid_4230_a0140",			      //Mean doggo dies and was misunderstood Fasadge

		//Heap 2------------------------------------------------------------------------------------------------------------------------------------------------
		//[Enter Heap]
		"eid_4030_a0090",			      //P-33 Start
		"eid_4030_a0110",			      //P-33 End
		//[Leaving Heap]

		//Forest------------------------------------------------------------------------------------------------------------------------------------------------
		//[Enter Forest]
		//[Leave Forest]

		//Aerie-------------------------------------------------------------------------------------------------------------------------------------------------
		//[Enter Aerie]
		"eid_4430_a0080",			      //Wendy start
		"eid_4430_a0084",			      //Wendy end

		//Shrine 2----------------------------------------------------------------------------------------------------------------------------------------------
		//[Shrine Path Enter]
		//[Shrine Enter]
		//[Bird Room Enter]

		//Devola & Popola---------------------------------------------------------------------------------------------------------------------------------------
		"eid_6000_a0110",			      //Dev & Pop 2 room
		//[FMV]

		//Shadowlord--------------------------------------------------------------------------------------------------------------------------------------------
		"eid_6000_a0160",			      //Shadowlord Start
		"eid_6000_a0180",			      //Shadowlord Phase 1 End
		"eid_8000_a0020"                  //B Last Cutscene
	};

	vars.Maps = new string[] {
		"B_NORTH_FIELD_01",     //0     //Northern Plains
		"B_STONE_FIELD_01",     //1     //Shrine Path
		"B_STONE_FIELD_02",     //2     //Gretels Room
		"B_STONE_TEMPLE_01",    //3     //Shrine
		"B_CENTER_LIBRARY_01",  //4     //Library
		"B_MOUNT_ROBOT_01",     //5     //Factory
		"B_MOUNT_FIELD_01",     //6     //Heap Outside
		"D_FOREST_FIELD_01",    //7     //Forest
		"B_SOUTH_FIELD_01",     //8     //SouthernPlains
		"B_MOUNT_ROBOT_03",     //9     //Minecart area
		"B_MOUNT_ROBOT_04",     //10    //Flyers skip area
		"B_SEASIDE_TOWN_01",    //11    //Seafront
		"B_CLIFF_VILLAGE_01",   //12    //Aerie
		"B_CASTLE_FIELD_01",    //13    //Bird room
		"B_CASTLE_FIELD_02",    //14    //BallRoom Entrance
	};

	vars.shrineCheck = 0;
	vars.SFCheck = 0;
}

start {
	vars.shrineCheck = 0;
	vars.SFCheck = 0;

	return current.Loading > 4;
}

split {

	//Map Splitting
	//Shrine---------------------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[0] && current.Map == vars.Maps[2]) { return true; }                                               //Plains to Shrine Path 1st time
	if (old.Map == vars.Maps[1] && current.Map == vars.Maps[2] && vars.shrineCheck != 1) { vars.shrineCheck++; return true; }  //Shrine Path to Shrine
	if (old.Map == vars.Maps[3] && current.Map == vars.Maps[2]) { return true; }                                               //Shrine to Roof
	if (old.Map == vars.Maps[2] && current.Map == vars.Maps[4]) { return true; }                                               //Kainé to Library
	
	//Heap-----------------------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[0] && current.Map == vars.Maps[5]) { return true; }                                               //Entering Heap 1st time
	if (old.Map == vars.Maps[6] && current.Map == vars.Maps[0]) { return true; }                                               //Leaving heap 1st and 2nd time
	
	//Forest---------------------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[0] && current.Map == vars.Maps[7]) { return true; }                                               //Enter forest
	if (old.Map == vars.Maps[7] && current.Map == vars.Maps[0]) { return true; }                                               //Leaving forest

	//Seafront-------------------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[8] && current.Map == vars.Maps[11] && vars.SFCheck == 0) { vars.SFCheck++; return true; }         //Enter Seafront
	if (current.Map == vars.Maps[11] && current.BreachedShip > old.BreachedShip) { return true; }                              //Breached ship

	//Heap 2---------------------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[0] && current.Map == vars.Maps[6]) { return true; }                                              //Entering heap without the cutscenes
	if (old.Map == vars.Maps[9] && current.Map == vars.Maps[10]) { return true; }                                             //Right after doing Minecart Skip
	
	//Aerie----------------------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[0] && current.Map == vars.Maps[12]) { return true; }                                             //Entering Aerie

	//Shrine 2 & Castle----------------------------------------------------------------------------------------------------------------------------------------
	if (old.Map == vars.Maps[2] && current.Map == vars.Maps[13]) { return true; }                                             //Shrine to Bird room
	if (old.Map == vars.Maps[0] && current.Map == vars.Maps[1]) { return true; }                                              //Plains to Shrine Path
	if (old.Map == vars.Maps[1] && current.Map == vars.Maps[3]) { return true; }                                              //Path to Shrine
	if (old.Map == vars.Maps[3] && current.Map == vars.Maps[1]) { return true; }                                              //Shrine to roof
	if (old.Map == vars.Maps[13] && current.Map == vars.Maps[14]) { return true; }                                            //Bird room to ballroom
	
	//Popola FMV-----------------------------------------------------------------------------------------------------------------------------------------------
	if(current.Map == "B_EID_6000_a0130" && current.Map != old.Map) { return true; }

	
	//Event Splitting
	foreach (string events in vars.Events) {
		if (current.Event == events && current.Event != old.Event) {
			print("haha stinky");
			return true;
		}
	}
}

isLoading {
	return current.Loading > 4;
}